zoukankan      html  css  js  c++  java
  • HDU 1069(DP)

    Monkey and Banana

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 24255    Accepted Submission(s): 12993


    Problem Description
    A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

    The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

    They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

    Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
     
    Input
    The input file will contain one or more test cases. The first line of each test case contains an integer n,
    representing the number of different blocks in the following data set. The maximum value for n is 30.
    Each of the next n lines contains three integers representing the values xi, yi and zi.
    Input is terminated by a value of zero (0) for n.
     
    Output
    For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
     
    Sample Input
    1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
     
    Sample Output
    Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
     
    题意:多组输入n,接下来n行每行三个数,分别表示一个长方体的长宽高。每种长方体有无数个。
        一个长方体可以搭在另一个长方体的前提条件是(可以是两个完全相同的长方体但是放的姿势不同),该上面的长方体的长宽分别比下面那个长方体的长宽都短
    问:最高可以搭多高
    思路:先处理长宽高,把长方体的每种姿势都存下来,在按照长和宽的长度进行排序,从上往下摆放。用dp[i]表示,当确定摆放了这个木块前i种木块搭配的最高的高度(因为状态转移的前提是
      a[i].x > a[j].x&& a[i].y > a[j].y,下一个木块是要和上一个比较的!)
     
    #include <iostream>
    #include <cmath>
    #include <cstdio>
    #include <cstring>
    #include <string>
    #include <map>
    #include <iomanip>
    #include <algorithm>
    #include <queue>
    #include <stack>
    #include <set>
    #include <vector>
    //const int maxn = 1e5+5;
    #define ll long long
    ll gcd(ll a,ll b){return b?gcd(b,a%b):a;}
    ll lcm(ll a,ll b){return a/gcd(a,b)*b;}
    
    #define MAX INT_MAX
    #define FOR(i,a,b) for( int i = a;i <= b;++i)
    #define bug cout<<"--------------"<<endl
    using namespace std;
    struct node
    {
        int x,y,z;
    }a[110000];
    int tot=0,maxx;
    int dp[110000];
    void add(int x,int y,int z)
    {
        a[++tot].x = x,a[tot].y = y,a[tot].z = z;
    }
    bool cmp(node a,node b)
    {
        if(a.x == b.x) return b.y < a.y;
        return a.x < b.x;
    }
    void clearr()
    {
        tot = 0,maxx = 0;
        memset(a,0,sizeof(a));
        memset(dp,0,sizeof(dp));
    }
    int casee = 0;
    int main()
    {
    
        int n;
        while((scanf("%d",&n)) != EOF)
        {
            if(n == 0) break;
            clearr();
            FOR(i,1,n)
            {
                int x,y,z;
                cin>>x>>y>>z;
                add(x,y,z);
                add(x,z,y);
                add(y,x,z);
                add(y,z,x);
                add(z,x,y);
                add(z,y,x);
            }
            sort(a+1,a+1+tot,cmp);
            //for(int i=1;i<=tot;++i) cout<<a[i].x<<" "<<a[i].y<<" "<<a[i].z<<endl;
            for(int i=1;i<=tot;++i)
            {
                dp[i] = a[i].z;
                for(int j=1;j<i;++j)
                {
                    if(a[i].x > a[j].x&& a[i].y > a[j].y) dp[i] = max(dp[j]+a[i].z,dp[i]);
                }
                maxx = max(maxx,dp[i]);
            }
            cout<<"Case "<<++casee<<": maximum height = "<<maxx<<endl;
        }
    }
  • 相关阅读:
    hadoop 2.7 添加或删除datanode节点
    hadoop HA集群的安装
    Linux-PAM认证
    [Notice]博客地址转移 vitostack.com
    WPF 自定义 MessageBox (相对完善版 v1.0.0.6)
    python2.7 倒计时
    Hadoop Streaming框架使用(二)
    Hadoop错误码速查
    Hadoop Streaming框架使用(一)
    python清空列表的方法
  • 原文地址:https://www.cnblogs.com/jrfr/p/11373413.html
Copyright © 2011-2022 走看看